## libyang 1.0.184-2+cl4.3.2u2

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8.12)

# force out-of-source build
if(NOT FORCE_INSRC_BUILD AND ${CMAKE_SOURCE_DIR} STREQUAL ${CMAKE_BINARY_DIR})
    message(FATAL_ERROR "In-source build is not allowed. Please make a standalone build directory and run CMake from there. You may need to remove CMakeCache.txt.")
endif()

project(libyang C)

# include custom Modules
set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} "${CMAKE_SOURCE_DIR}/CMakeModules/")

include(GNUInstallDirs)
include(CheckSymbolExists)
include(UseCompat)

set(LIBYANG_DESCRIPTION "libyang is YANG data modelling language parser and toolkit written (and providing API) in C.")

# Correct RPATH usage on OS X
set(CMAKE_MACOSX_RPATH TRUE)

# Version of the project
# Generic version of not only the library. Major version is reserved for really big changes of the project,
# minor version changes with added functionality (new tool, functionality of the tool or library, ...) and
# micro version is changed with a set of small changes or bugfixes anywhere in the project.
set(LIBYANG_MAJOR_VERSION 1)
set(LIBYANG_MINOR_VERSION 0)
set(LIBYANG_MICRO_VERSION 184)
set(LIBYANG_VERSION ${LIBYANG_MAJOR_VERSION}.${LIBYANG_MINOR_VERSION}.${LIBYANG_MICRO_VERSION})

# Version of the library
# Major version is changed with every backward non-compatible API/ABI change in libyang, minor version changes
# with backward compatible change and micro version is connected with any internal change of the library.
set(LIBYANG_MAJOR_SOVERSION 1)
set(LIBYANG_MINOR_SOVERSION 9)
set(LIBYANG_MICRO_SOVERSION 2)
set(LIBYANG_SOVERSION_FULL ${LIBYANG_MAJOR_SOVERSION}.${LIBYANG_MINOR_SOVERSION}.${LIBYANG_MICRO_SOVERSION})
set(LIBYANG_SOVERSION ${LIBYANG_MAJOR_SOVERSION})

# check the supported platform
if(NOT UNIX)
    message(FATAL_ERROR "Only *nix like systems are supported.")
endif()

# set default build type if not specified by user
if(NOT CMAKE_BUILD_TYPE)
    set(CMAKE_BUILD_TYPE debug)
endif()

set(CMAKE_C_FLAGS         "${CMAKE_C_FLAGS} -Wall -Wextra -std=gnu99")
set(CMAKE_C_FLAGS_RELEASE "-O3 -DNDEBUG")
set(CMAKE_C_FLAGS_PACKAGE "-g -O3 -DNDEBUG")
set(CMAKE_C_FLAGS_DEBUG   "-g -Og")

# options
if((CMAKE_BUILD_TYPE STREQUAL debug) OR (CMAKE_BUILD_TYPE STREQUAL Package))
    option(ENABLE_BUILD_TESTS "Build tests" ON)
    option(ENABLE_VALGRIND_TESTS "Build tests with valgrind" ON)
else()
    option(ENABLE_BUILD_TESTS "Build tests" OFF)
    option(ENABLE_VALGRIND_TESTS "Build tests with valgrind" OFF)
endif()
option(ENABLE_CALLGRIND_TESTS "Build performance tests to be run with callgrind" OFF)

option(ENABLE_CACHE "Enable data caching for schemas and hash tables for data (time-efficient at the cost of increased space-complexity)" ON)
option(ENABLE_LATEST_REVISIONS "Enable reusing of latest revisions of schemas" ON)
option(ENABLE_LYD_PRIV "Add a private pointer also to struct lyd_node (data node structure), just like in struct lys_node, for arbitrary user data" OFF)
option(ENABLE_FUZZ_TARGETS "Build target programs suitable for fuzzing with AFL" OFF)
set(PLUGINS_DIR "${CMAKE_INSTALL_PREFIX}/${CMAKE_INSTALL_LIBDIR}/libyang${LIBYANG_MAJOR_SOVERSION}" CACHE STRING "Directory with libyang plugins (extensions and user types), should include major SO version")

if(ENABLE_CACHE)
    set(LY_ENABLED_CACHE 1)
endif()
if(ENABLE_LATEST_REVISIONS)
    set(LY_ENABLED_LATEST_REVISIONS 1)
endif()
if(ENABLE_LYD_PRIV)
    set(LY_ENABLED_LYD_PRIV 1)
endif()

if(CMAKE_C_COMPILER_ID STREQUAL "GNU")
    set(COMPILER_UNUSED_ATTR "UNUSED_ ## x __attribute__((__unused__))")
    set(COMPILER_PACKED_ATTR "__attribute__((__packed__))")
elseif(CMAKE_C_COMPILER_ID STREQUAL "Clang")
    # require at least clang 3.0
    if (CMAKE_C_COMPILER_VERSION VERSION_LESS 3.0)
        message(FATAL_ERROR "Clang version must be at least 3.0!")
    endif()
    set(COMPILER_UNUSED_ATTR "UNUSED_ ## x __attribute__((__unused__))")
    set(COMPILER_PACKED_ATTR "__attribute__((__packed__))")
else()
    message(WARNING "You are using an unknown compiler, it must support C11 standard \"_Generic\" statement"
        " or the \"__builtin_types_compatible_p\" built-in function.")
    set(COMPILER_UNUSED_ATTR "UNUSED_ ## x")
    set(COMPILER_PACKED_ATTR "")
endif()

include_directories(${PROJECT_BINARY_DIR}/src ${PROJECT_SOURCE_DIR}/src)
configure_file(${PROJECT_SOURCE_DIR}/src/libyang.h.in ${PROJECT_BINARY_DIR}/src/libyang.h @ONLY)
configure_file(${PROJECT_SOURCE_DIR}/src/common.h.in ${PROJECT_BINARY_DIR}/src/common.h @ONLY)

set(EXTENSIONS_PLUGINS_DIR_MACRO "${PLUGINS_DIR}/extensions")
set(USER_TYPES_PLUGINS_DIR_MACRO "${PLUGINS_DIR}/user_types")

# setup bindings
set(GEN_LANGUAGE_BINDINGS 0 CACHE BOOL "Enable language bindings generation.")
set(GEN_CPP_BINDINGS 1 CACHE BOOL "Enable C++ bindings.")
# Python bindings depend on C++ bindings because of SWIG
set(GEN_PYTHON_BINDINGS 1 CACHE BOOL "Enable Python bindings.")
set(GEN_PYTHON_VERSION "3" CACHE STRING "Python version")
set(GEN_JAVASCRIPT_BINDINGS 0 CACHE BOOL "Enable JavaScript bindings.")
set(GEN_JAVA_BINDINGS 0 CACHE BOOL "Enable Java bindings.")

find_package(FLEX)
find_package(BISON)
find_program(SED_TOOL NAMES sed)

if(NOT BISON_FOUND)
    message(WARNING "Missing Bison.\nYou won't be able to generate source codes from changed flex/bison files.\nCompiling libyang should still works fine.")
elseif (NOT FLEX_FOUND)
    message(WARNING "Missing Flex.\nYou won't be able to generate source codes from changed flex/bison files.\nCompiling libyang should still works fine.")
else()
    if (BISON_VERSION VERSION_LESS 3)
        set(EMPTYDIR "")
    else ()
        set(EMPTYDIR "%empty")
    endif()
    configure_file(${PROJECT_SOURCE_DIR}/src/yang.y.in ${PROJECT_BINARY_DIR}/src/yang.y)
    add_custom_target(bison
        WORKING_DIRECTORY ${PROJECT_SOURCE_DIR}/src
        COMMAND bison -l -o parser_yang_bis.c --defines=parser_yang_bis.h ${PROJECT_BINARY_DIR}/src/yang.y
        COMMAND flex -8 -L -o parser_yang_lex.c --header-file=parser_yang_lex.h yang.l
        COMMAND ${SED_TOOL} -i 's/int yychar\;/int yychar\;\\nchar *s = NULL, *tmp_s = NULL, *ext_name = NULL\;\\nstruct lys_module *trg = NULL\;\\nstruct lys_node *tpdf_parent = NULL, *data_node = NULL\;\\nstruct lys_ext_instance_complex *ext_instance = NULL\;\\nint is_ext_instance\;\\nvoid *actual = NULL\;\\nenum yytokentype backup_type, actual_type = MODULE_KEYWORD\;\\nint64_t cnt_val = 0\;\\nint is_value = 0\;\\nvoid *yang_type = NULL\;/' parser_yang_bis.c
    )
endif()

# by default build shared library
# static build requires static libpcre library
option(ENABLE_STATIC "Build static (.a) library" OFF)

set(libsrc
    src/common.c
    src/context.c
    src/log.c
    src/hash_table.c
    src/resolve.c
    src/validation.c
    src/xml.c
    src/parser.c
    src/parser_yin.c
    src/parser_xml.c
    src/parser_json.c
    src/parser_lyb.c
    src/parser_yang_bis.c
    src/parser_yang_lex.c
    src/parser_yang.c
    src/tree_schema.c
    src/tree_data.c
    src/plugins.c
    src/printer.c
    src/xpath.c
    src/printer_yang.c
    src/printer_yin.c
    src/printer_json_schema.c
    src/printer_xml.c
    src/printer_tree.c
    src/printer_info.c
    src/printer_json.c
    src/printer_lyb.c
    src/yang_types.c)

set(lintsrc
    tools/lint/main.c
    tools/lint/main_ni.c
    tools/lint/commands.c
    tools/lint/completion.c
    tools/lint/configuration.c
    linenoise/linenoise.c)

set(resrc
    tools/re/main.c)

set(yang2yinsrc
    tools/yang2yin/main.c)

set(headers
    src/tree_schema.h
    src/tree_data.h
    src/extensions.h
    src/user_types.h
    src/xml.h
    src/dict.h)

# link compat
use_compat()

# create static libyang library
if(ENABLE_STATIC)
    add_definitions(-DSTATIC)
    set(CMAKE_EXE_LINKER_FLAGS -static)
    set(CMAKE_FIND_LIBRARY_SUFFIXES .a)
    set(CMAKE_EXE_LINK_DYNAMIC_C_FLAGS)       # remove -Wl,-Bdynamic
    set(CMAKE_EXE_LINK_DYNAMIC_CXX_FLAGS)
    add_library(yang STATIC ${libsrc} $<TARGET_OBJECTS:compat>)

    # switch off the tests
    if(ENABLE_BUILD_TESTS)
        message(WARNING "Tests are disabled in case of static build")
        set(ENABLE_BUILD_TESTS OFF)
        set(ENABLE_VALGRIND_TESTS OFF)
    endif(ENABLE_BUILD_TESTS)
    if(ENABLE_VALGRIND_TESTS)
        message(WARNING "Tests are disabled in case of static build")
        set(ENABLE_VALGRIND_TESTS OFF)
    endif(ENABLE_VALGRIND_TESTS)
else()
    set(CMAKE_POSITION_INDEPENDENT_CODE TRUE)
    add_library(yangobj OBJECT ${libsrc})
    add_library(yang SHARED $<TARGET_OBJECTS:yangobj> $<TARGET_OBJECTS:compat>)

    #only for tests with visible internal symbols
    add_library(yangobj_tests OBJECT ${libsrc})

    #link dl
    target_link_libraries(yang ${CMAKE_DL_LIBS})

    set_target_properties(yangobj PROPERTIES COMPILE_FLAGS "-fvisibility=hidden")
endif()

set_target_properties(yang PROPERTIES VERSION ${LIBYANG_SOVERSION_FULL} SOVERSION ${LIBYANG_SOVERSION})

# link math
target_link_libraries(yang m)

# find pthreads
set(CMAKE_THREAD_PREFER_PTHREAD TRUE)
find_package(Threads REQUIRED)
target_link_libraries(yang ${CMAKE_THREAD_LIBS_INIT})

# find PCRE library
unset(PCRE_LIBRARY CACHE)
find_package(PCRE REQUIRED)
include_directories(${PCRE_INCLUDE_DIRS})
target_link_libraries(yang ${PCRE_LIBRARIES})

install(TARGETS yang DESTINATION ${CMAKE_INSTALL_LIBDIR})
install(FILES ${headers} ${PROJECT_BINARY_DIR}/src/libyang.h DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}/libyang)

find_package(PkgConfig)
if(PKG_CONFIG_FOUND)
    # generate and install pkg-config file
    configure_file("libyang.pc.in" "libyang.pc" @ONLY)
    install(FILES "${CMAKE_CURRENT_BINARY_DIR}/libyang.pc" DESTINATION "${CMAKE_INSTALL_LIBDIR}/pkgconfig")
    # check that pkg-config includes the used path
    execute_process(COMMAND ${PKG_CONFIG_EXECUTABLE} --variable pc_path pkg-config RESULT_VARIABLE RETURN OUTPUT_VARIABLE PC_PATH ERROR_QUIET)
    if(RETURN EQUAL 0)
	string(STRIP "${PC_PATH}" PC_PATH)
	set(PC_PATH "${PC_PATH}:$ENV{PKG_CONFIG_PATH}")
        string(REGEX MATCH "${CMAKE_INSTALL_PREFIX}/${CMAKE_INSTALL_LIBDIR}/pkgconfig" SUBSTR "${PC_PATH}")
        string(LENGTH "${SUBSTR}" SUBSTR_LEN)
        if(SUBSTR_LEN EQUAL 0)
            message(WARNING "pkg-config will not detect the new package after installation, adjust PKG_CONFIG_PATH using \"export PKG_CONFIG_PATH=\${PKG_CONFIG_PATH}:${CMAKE_INSTALL_PREFIX}/${CMAKE_INSTALL_LIBDIR}/pkgconfig\".")
        endif()
    endif()
endif()

# generate doxygen documentation for libyang API
find_package(Doxygen)
if(DOXYGEN_FOUND)
    find_program(DOT_PATH dot PATH_SUFFIXES graphviz2.38/bin graphviz/bin)
    if(DOT_PATH)
        set(HAVE_DOT "YES")
    else()
        set(HAVE_DOT "NO")
        message(AUTHOR_WARNING "Doxygen: to generate UML diagrams please install graphviz")
    endif()
    add_custom_target(doc
            COMMAND ${DOXYGEN_EXECUTABLE} ${CMAKE_BINARY_DIR}/Doxyfile
            WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR})
    configure_file(Doxyfile.in Doxyfile)
endif()

# clean cmake cache
add_custom_target(cclean
        COMMAND make clean
        COMMAND find . -iname '*cmake*' -not -name CMakeLists.txt -not -path './CMakeModules*' -exec rm -rf {} +
        COMMAND rm -rf Makefile Doxyfile
        WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR})

# YANG extensions plugins
set(EXTENSIONS_LIST "nacm" "metadata" "yangdata")
# if the tests are enabled, build libyang_ext_test
if(ENABLE_BUILD_TESTS)
    find_package(CMocka 1.0.0)
    if(CMOCKA_FOUND AND CMAKE_BUILD_TYPE MATCHES debug)
        list(APPEND EXTENSIONS_LIST "libyang_ext_test")
    endif(CMOCKA_FOUND AND CMAKE_BUILD_TYPE MATCHES debug)
endif()

if(ENABLE_STATIC)
    set(EXTENSIONS_LIST_SIZE " 0 ")
    set(ITEM 0)
    foreach(EXTENSION ${EXTENSIONS_LIST})
        add_library(${EXTENSION} STATIC "src/extensions/${EXTENSION}.c")
        target_link_libraries(yang ${EXTENSION})
        set(EXTENSIONS_LIST_SIZE "${EXTENSIONS_LIST_SIZE} + lyext_size(${EXTENSION})")

=== swig/CMakeLists.txt ===
project(libyang-cpp)

set(CMAKE_CXX_FLAGS         "${CMAKE_CXX_FLAGS} -Wall -Wextra -std=c++11")
set(CMAKE_CXX_FLAGS_RELEASE "-O2 -DNDEBUG")
set(CMAKE_CXX_FLAGS_PACKAGE "-g -O2 -DNDEBUG")
set(CMAKE_CXX_FLAGS_DEBUG   "-g -Og")

# temporary bugfix
add_compile_options(-std=c++11)

# find SWIG package
if(GEN_LANGUAGE_BINDINGS)
    find_package(SWIG 3.0.12)
    if(NOT SWIG_FOUND)
        message(WARNING "SWIG library not found")
    else()
        include(${SWIG_USE_FILE})
    endif()
endif()

# find Python package
if(GEN_PYTHON_BINDINGS AND SWIG_FOUND)
    message(STATUS "Python version ${GEN_PYTHON_VERSION} was selected")
    unset(PYTHON_LIBRARY CACHE)
    unset(PYTHON_EXECUTABLE CACHE)
    unset(PYTHON_INCLUDE_DIR CACHE)
    unset(PYTHON_LIBRARY_DEBUG CACHE)
    if(${GEN_PYTHON_VERSION} STREQUAL "2")
        find_package(PythonInterp 2 REQUIRED)
        find_package(PythonLibs 2 REQUIRED)
        if(NOT PYTHONLIBS_FOUND)
            message(WARNING "Did not found Python version 2.x")
            message(STATUS "Libyang supports Python 2.x and Python 3.x")
        endif()
    elseif(${GEN_PYTHON_VERSION} STREQUAL "3")
        find_package(PythonInterp 3 REQUIRED)
        find_package(PythonLibs 3 REQUIRED)
        if(NOT PYTHONLIBS_FOUND)
            message(WARNING "Did not found Python version 3.x")
            message(STATUS "Libyang supports Python 2.x and Python 3.x")
        endif()
    else()
        message(WARNING "Libyang supports Python 2.x and Python 3.x")
    endif()
endif()

set(LIBYANG_CPP_SOURCES
    ${CMAKE_SOURCE_DIR}/swig/cpp/src/Xml.cpp
    ${CMAKE_SOURCE_DIR}/swig/cpp/src/Libyang.cpp
    ${CMAKE_SOURCE_DIR}/swig/cpp/src/Tree_Data.cpp
    ${CMAKE_SOURCE_DIR}/swig/cpp/src/Tree_Schema.cpp
    ${CMAKE_SOURCE_DIR}/swig/cpp/src/Internal.cpp)

set(LIBYANG_HPP_SOURCES
    ${CMAKE_SOURCE_DIR}/swig/cpp/src/Xml.hpp
    ${CMAKE_SOURCE_DIR}/swig/cpp/src/Libyang.hpp
    ${CMAKE_SOURCE_DIR}/swig/cpp/src/Tree_Data.hpp
    ${CMAKE_SOURCE_DIR}/swig/cpp/src/Tree_Schema.hpp
    ${CMAKE_SOURCE_DIR}/swig/cpp/src/Internal.hpp)

FUNCTION(PREPEND var prefix)
    SET(listVar "")
    FOREACH(f ${ARGN})
        LIST(APPEND listVar "${prefix}/${f}")
    ENDFOREACH(f)
    SET(${var} "${listVar}" PARENT_SCOPE)
ENDFUNCTION(PREPEND)

PREPEND(abs_libsrc ${CMAKE_SOURCE_DIR} ${libsrc})

if(ENABLE_STATIC)
    add_library(libyang-cpp STATIC ${LIBYANG_CPP_SOURCES})
else(ENABLE_STATIC)
    add_library(libyang-cpp SHARED ${LIBYANG_CPP_SOURCES})
endif(ENABLE_STATIC)
SET_TARGET_PROPERTIES(libyang-cpp PROPERTIES
    VERSION ${LIBYANG_SOVERSION_FULL} SOVERSION ${LIBYANG_SOVERSION} PREFIX "")

# include custom Modules
set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} "${CMAKE_SOURCE_DIR}/CMakeModules/")

include_directories(${CMAKE_SOURCE_DIR})
include_directories("${CMAKE_CURRENT_SOURCE_DIR}/cpp/src")
target_link_libraries(libyang-cpp yang)

if(PKG_CONFIG_FOUND)
    configure_file("${CMAKE_CURRENT_SOURCE_DIR}/libyang-cpp.pc.in" "${CMAKE_CURRENT_BINARY_DIR}/libyang-cpp.pc" @ONLY)
    install(FILES "${CMAKE_CURRENT_BINARY_DIR}/libyang-cpp.pc" DESTINATION "${CMAKE_INSTALL_LIBDIR}/pkgconfig")
endif()

# install binary
install(TARGETS libyang-cpp DESTINATION ${CMAKE_INSTALL_LIBDIR})
install(FILES ${LIBYANG_HPP_SOURCES} DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}/libyang)

if (GEN_CPP_BINDINGS)
    add_subdirectory(cpp/examples)
    if (ENABLE_BUILD_TESTS)
        add_subdirectory(cpp/tests)
    endif()
endif()

if(NOT ENABLE_STATIC AND GEN_JAVASCRIPT_BINDINGS)
    message(WARNING "Can't create Javascript bindings with a shared library, please use -DENABLE_STATIC")
elseif(ENABLE_STATIC AND GEN_JAVASCRIPT_BINDINGS)
    add_subdirectory(javascript)
endif()

if(ENABLE_STATIC AND GEN_JAVA_BINDINGS)
    message(WARNING "Can't create a static Java module")
elseif(NOT ENABLE_STATIC AND GEN_JAVA_BINDINGS)
    add_subdirectory(java)
endif()

=== swig/python/CMakeLists.txt ===
set(PYTHON_SWIG_BINDING yang)
set(PYTHON_SWIG_TARGET yang${CUR_PYTHON_VERSION})
include_directories(${PYTHON_INCLUDE_PATH})
include_directories(${CMAKE_CURRENT_SOURCE_DIR})
include_directories(${PROJECT_SOURCE_DIR}/cpp/src)

set(CMAKE_SWIG_FLAGS "-c++")
set(CMAKE_SWIG_FLAGS "-I${PROJECT_SOURCE_DIR}" "-I${PROJECT_SOURCE_DIR}/cpp/src" "-interface" "_${PYTHON_SWIG_BINDING}")
set(CMAKE_SWIG_OUTDIR ${CMAKE_CURRENT_BINARY_DIR})

set_source_files_properties(${PYTHON_SWIG_BINDING}.i PROPERTIES CPLUSPLUS ON PREFIX "" SWIG_MODULE_NAME ${PYTHON_SWIG_BINDING})

if(${CMAKE_VERSION} VERSION_LESS "3.8.0")
    swig_add_module(${PYTHON_SWIG_TARGET} python ${PYTHON_SWIG_BINDING}.i)
else()
    swig_add_library(${PYTHON_SWIG_TARGET} LANGUAGE python SOURCES ${PYTHON_SWIG_BINDING}.i)
endif()
swig_link_libraries(${PYTHON_SWIG_TARGET} ${PYTHON_LIBRARIES} libyang-cpp)

set_target_properties(_${PYTHON_SWIG_TARGET} PROPERTIES OUTPUT_NAME "_yang${PYTHON_EXT_SUFFIX}" SUFFIX "")

# Generate header with SWIG run-time functions
execute_process(COMMAND ${SWIG_EXECUTABLE} -python -external-runtime ${CMAKE_CURRENT_BINARY_DIR}/swigpyrun.h)

add_custom_command(TARGET ${PYTHON_SWIG_TARGET}_swig_compilation POST_BUILD
        COMMAND sed -e "'s/\\(inst =.*tp_new.*\\)Py_None, Py_None);/PyObject *tup = PyTuple_New(0); \\1tup, Py_None); Py_DECREF(tup);/'" < swigpyrun.h > swigpyrun.h.new
        COMMAND sed -e "'s/\\(inst =.*tp_new.*\\)Py_None, Py_None);/PyObject *tup = PyTuple_New(0); \\1tup, Py_None); Py_DECREF(tup);/'" < yangPYTHON_wrap.cxx > yangPYTHON_wrap.cxx.new
        COMMAND diff -q swigpyrun.h swigpyrun.h.new || mv swigpyrun.h.new swigpyrun.h
        COMMAND diff -q yangPYTHON_wrap.cxx yangPYTHON_wrap.cxx.new || mv yangPYTHON_wrap.cxx.new yangPYTHON_wrap.cxx
        WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}
        )

file(COPY "examples" DESTINATION ${CMAKE_CURRENT_BINARY_DIR})

install( TARGETS _${PYTHON_SWIG_TARGET} DESTINATION ${PYTHON_MODULE_PATH})
install( FILES "${CMAKE_CURRENT_BINARY_DIR}/${PYTHON_SWIG_BINDING}.py" DESTINATION ${PYTHON_MODULE_PATH})
install( FILES "${CMAKE_CURRENT_BINARY_DIR}/swigpyrun.h" DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}/libyang)

if(ENABLE_BUILD_TESTS)
    set(PY2_SWIG_DIR ${CMAKE_CURRENT_BINARY_DIR})
    set(PY2_TEST_DIR ${PY2_SWIG_DIR}/tests)

    file(COPY "tests" DESTINATION "${CMAKE_CURRENT_BINARY_DIR}")
    file(COPY "run_python_test.sh" DESTINATION "${PY2_SWIG_DIR}")

    macro(ADD_PYTHON_TEST TEST_NAME)
        add_test(NAME python_${TEST_NAME}
            COMMAND sh ${PY2_SWIG_DIR}/run_python_test.sh
            "${CMAKE_BINARY_DIR}/src:${CMAKE_BINARY_DIR}/tests:${PY2_TEST_DIR}"
            "${PY2_SWIG_DIR}:${PROJECT_SOURCE_DIR}/swig/python:${PYTHON_BUILD_DIR}"
            "${PYTHON_EXECUTABLE}"
            "${PY2_SWIG_DIR}/tests/${TEST_NAME}.py"
            "${CMAKE_BINARY_DIR}"
            WORKING_DIRECTORY ${CMAKE_BINARY_DIR}
            )
    endmacro(ADD_PYTHON_TEST)

    ADD_PYTHON_TEST(test_libyang)
    ADD_PYTHON_TEST(test_tree_data)
    ADD_PYTHON_TEST(test_tree_schema)

    add_custom_command(TARGET ${SWIG_MODULE_${PYTHON_SWIG_TARGET}_REAL_NAME} POST_BUILD
            COMMAND cp "${CMAKE_CURRENT_BINARY_DIR}/_yang${PYTHON_EXT_SUFFIX}" ${PY2_SWIG_DIR}/tests/_yang.so
            COMMAND cp "${CMAKE_CURRENT_BINARY_DIR}/${PYTHON_SWIG_BINDING}.py" ${PY2_SWIG_DIR}/tests
        WORKING_DIRECTORY ${CMAKE_BINARY_DIR}
        )

    configure_file("${CMAKE_CURRENT_SOURCE_DIR}/config.py.in" "${CMAKE_CURRENT_BINARY_DIR}/tests/config.py" ESCAPE_QUOTES @ONLY)
endif()

=== debian/changelog ===
libyang (1.0.184-2+cl4.3.2u2) unstable; urgency=medium

  * Specifying version to replace for libyang0.16 

 -- dev-support <dev-support@cumulusnetworks.com>  Wed, 15 Nov 2023 17:55:32 -0800

libyang (1.0.184-2+cl4.3.2u1) unstable; urgency=medium

  * Adding entry in debian/control to mark libyang1 as replacing libyang0.16
    on an upgrade 

 -- dev-support <dev-support@cumulusnetworks.com>  Wed, 15 Nov 2023 13:45:32 -0800

libyang (1.0.184-2+cl4.3.0u1) unstable; urgency=medium

  * upstream 1.0.184 (0.16-r3) release

 -- dev-support <dev-support@cumulusnetworks.com>  Mon, 23 Nov 2020 14:10:41 -0800

libyang (0.16.105-2+cl4.2.1u1) unstable; urgency=medium

  * [cumulus] Build with ENABLE_CACHE=OFF (CM-31452)

 -- dev-support <dev-support@cumulusnetworks.com>  Wed, 16 Sep 2020 14:14:43 -0700

=== debian/control ===
Source: libyang
Section: libs
Homepage: https://netopeer.liberouter.org/
Maintainer: David Lamparter <equinox-debian@diac24.net>
Uploaders: CESNET <rkrejci@cesnet.cz>
Priority: optional
Standards-Version: 4.2.1
Build-Depends:
 bison,
 cmake,
 debhelper (>= 11~),
 dh-python,
 libcmocka-dev <!nocheck>,
 libpcre3-dev,
 swig (>= 3.0.12),
 python3-all-dev,
 python3-all-dbg,
 pkg-config
Vcs-Browser: https://github.com/CESNET/libyang/tree/debian
Vcs-Git: https://github.com/CESNET/libyang.git -b debian

Package: libyang1
Depends:
 ${misc:Depends},
 ${shlibs:Depends}
Replaces: libyang0.16 (>= 0.16.105+really)
Breaks: libyang0.16 (>= 0.16.105+really)
Architecture: any
Description: parser toolkit for IETF YANG data modeling - runtime
 Libyang implements functions to process schemas expressed in the
 YANG data modeling language defined by the IETF in RFCs 6020/7950.
 Schemas expressed in this language primarily describe configuration
 used by larger network equipment like routers and switches.
 .
 In addition to handling the schemas itself, the library also provides
 functions to process data described by the schemas.
 .
 The library is implemented in C and provides an API for other software
 to use in processing configurations.

Package: libyang-dev
Depends:
 ${misc:Depends},
 libpcre3-dev,
 libyang1 (= ${binary:Version})
Section: libdevel
Architecture: any
Description: parser toolkit for IETF YANG data modeling - development files
 Libyang implements functions to process schemas expressed in the
 YANG data modeling language defined by the IETF in RFCs 6020/7950.
 Schemas expressed in this language primarily describe configuration
 used by larger network equipment like routers and switches.
 .
 In addition to handling the schemas itself, the library also provides
 functions to process data described by the schemas.
 .
 This package contains the C headers, a pkgconfig file, and .so entry point
 for libyang.

Package: yang-tools
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
 libyang1 (= ${binary:Version})
Section: devel
Architecture: any
Description: parser toolkit for IETF YANG data modeling - executable tools
 This package provides the "yanglint" and "yangre" tools which can be used
 during the creation of IETF YANG schemas.  The tools are not generally
 useful for normal operation where libyang primarily processes configuration
 data, not schemas.

Package: libyang-cpp1
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
 libyang1 (= ${binary:Version})
Architecture: any
Description: parser toolkit for IETF YANG data modeling - C++ runtime
 Partially SWIG-generated bindings to use libyang with a C++ API.
 The functionality is the same as in libyang, the C++ code links wraps
 and uses libyang C code.

Package: libyang-cpp-dev
Depends:
 ${misc:Depends},
 libyang-cpp1 (= ${binary:Version}),
 libyang-dev (= ${binary:Version})
Section: libdevel
Architecture: any
Description: parser toolkit for IETF YANG data modeling - C++ development files
 Partially SWIG-generated bindings to use libyang with a C++ API.
 The functionality is the same as in libyang, the C++ code links wraps
 and uses libyang C code.
 .
 This is the accompanying development package, containing headers, a
 pkgconfig file, and .so entry point for the libyang C++ bindings.

#Package: python3-yang
#Depends:
# ${misc:Depends},
# ${shlibs:Depends},
# ${python3:Depends},
# libyang-cpp1 (= ${binary:Version})
#Section: python
#Architecture: any
#Description: parser toolkit for IETF YANG data modeling - python3 support
# This package allows using libyang functionality to load IETF YANG models
# and data from Python3 code.
# .
# The bindings are partially generated by SWIG.
#
#Package: python3-yang-dbg
#Depends:
# ${misc:Depends},
# ${shlibs:Depends},
# ${python3:Depends},
# python3-yang (=${binary:Version})
#Section: debug
#Architecture: any
#Description: parser toolkit for IETF YANG data modeling - python3 debug
# This package allows using libyang functionality to load IETF YANG models
# and data from Python3 code.
# .
# This package contains support for debug versions of Python.

=== debian/rules ===
#!/usr/bin/make -f
export DH_VERBOSE=1
export DEB_BUILD_MAINT_OPTIONS = hardening=+all

include /usr/share/dpkg/architecture.mk

%:
	dh $@ --with python3

override_dh_auto_configure:
	dh_auto_configure -- \
		-DCMAKE_BUILD_TYPE:String="Package" \
		-DENABLE_LYD_PRIV=ON \
		-DENABLE_CACHE=ON \
		-DCMAKE_INSTALL_PREFIX=/usr \
		-DFORCE_INSRC_BUILD=ON \
		-DGEN_LANGUAGE_BINDINGS=ON \
		-DGEN_JAVA_BINDINGS=OFF \
		-DGEN_JAVASCRIPT_BINDINGS=OFF \
		-DGEN_CPP_BINDINGS=ON \
		-DGEN_PYTHON_BINDINGS=ON \
		-DGEN_PYTHON_VERSION=3 \
	    .

#override_dh_auto_install:
#	dh_auto_install
#	-rm -rf debian/tmp/usr/lib/python3
#	set -e; /usr/bin/py3versions -s | sed -e 's/python\([^ ]\+\)/\1/g' -e 's/ /\n/g' | while read V; do \
#		make -C swig/python DESTDIR=`pwd`/debian/python3-yang     install; \
#	done
#	set -e; /usr/bin/py3versions -s | sed -e 's/python\(3\.[0-7]\)/\1dm/g' -e 's/python\([^ ]\+\)/\1d/g' -e 's/ /\n/g' | while read V; do \
#		make -C swig/python DESTDIR=`pwd`/debian/python3-yang-dbg install; \
#	done
#	-rm -rf debian/python3-yang/usr/include
#	-rm -rf debian/python3-yang-dbg/usr/include

#override_dh_strip:
#	dh_strip -Npython3-yang-dbg -Npython3-yang
#	dh_strip -ppython3-yang --dbg-package=python3-yang-dbg

override_dh_makeshlibs:
	dh_makeshlibs -Xextensions -Xuser_types

override_dh_auto_test:
ifeq ($(filter nocheck,$(DEB_BUILD_OPTIONS)),)
	make -C obj-$(DEB_HOST_GNU_TYPE) test ARGS=-V
endif

## libyang 1.0.225

=== CMakeLists.txt ===
--- 
+++ 
@@ -25,15 +25,15 @@
 # micro version is changed with a set of small changes or bugfixes anywhere in the project.
 set(LIBYANG_MAJOR_VERSION 1)
 set(LIBYANG_MINOR_VERSION 0)
-set(LIBYANG_MICRO_VERSION 184)
+set(LIBYANG_MICRO_VERSION 225)
 set(LIBYANG_VERSION ${LIBYANG_MAJOR_VERSION}.${LIBYANG_MINOR_VERSION}.${LIBYANG_MICRO_VERSION})
 
 # Version of the library
 # Major version is changed with every backward non-compatible API/ABI change in libyang, minor version changes
 # with backward compatible change and micro version is connected with any internal change of the library.
 set(LIBYANG_MAJOR_SOVERSION 1)
-set(LIBYANG_MINOR_SOVERSION 9)
-set(LIBYANG_MICRO_SOVERSION 2)
+set(LIBYANG_MINOR_SOVERSION 10)
+set(LIBYANG_MICRO_SOVERSION 17)
 set(LIBYANG_SOVERSION_FULL ${LIBYANG_MAJOR_SOVERSION}.${LIBYANG_MINOR_SOVERSION}.${LIBYANG_MICRO_SOVERSION})
 set(LIBYANG_SOVERSION ${LIBYANG_MAJOR_SOVERSION})
 
@@ -47,7 +47,7 @@
     set(CMAKE_BUILD_TYPE debug)
 endif()
 
-set(CMAKE_C_FLAGS         "${CMAKE_C_FLAGS} -Wall -Wextra -std=gnu99")
+set(CMAKE_C_FLAGS         "${CMAKE_C_FLAGS} -Wall -Wextra -std=gnu99 -fno-strict-aliasing")
 set(CMAKE_C_FLAGS_RELEASE "-O3 -DNDEBUG")
 set(CMAKE_C_FLAGS_PACKAGE "-g -O3 -DNDEBUG")
 set(CMAKE_C_FLAGS_DEBUG   "-g -Og")
@@ -246,16 +246,16 @@
 install(TARGETS yang DESTINATION ${CMAKE_INSTALL_LIBDIR})
 install(FILES ${headers} ${PROJECT_BINARY_DIR}/src/libyang.h DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}/libyang)
 
+# generate pkg-config file
+configure_file("libyang.pc.in" "libyang.pc" @ONLY)
 find_package(PkgConfig)
 if(PKG_CONFIG_FOUND)
-    # generate and install pkg-config file
-    configure_file("libyang.pc.in" "libyang.pc" @ONLY)
     install(FILES "${CMAKE_CURRENT_BINARY_DIR}/libyang.pc" DESTINATION "${CMAKE_INSTALL_LIBDIR}/pkgconfig")
     # check that pkg-config includes the used path
     execute_process(COMMAND ${PKG_CONFIG_EXECUTABLE} --variable pc_path pkg-config RESULT_VARIABLE RETURN OUTPUT_VARIABLE PC_PATH ERROR_QUIET)
     if(RETURN EQUAL 0)
-	string(STRIP "${PC_PATH}" PC_PATH)
-	set(PC_PATH "${PC_PATH}:$ENV{PKG_CONFIG_PATH}")
+        string(STRIP "${PC_PATH}" PC_PATH)
+        set(PC_PATH "${PC_PATH}:$ENV{PKG_CONFIG_PATH}")
         string(REGEX MATCH "${CMAKE_INSTALL_PREFIX}/${CMAKE_INSTALL_LIBDIR}/pkgconfig" SUBSTR "${PC_PATH}")
         string(LENGTH "${SUBSTR}" SUBSTR_LEN)
         if(SUBSTR_LEN EQUAL 0)

=== packages/CMakeLists.txt ===
set(PACKAGE "libyang")
set(CPP_PACKAGE "libyang-cpp")
set(PYTHON_PACKAGE "python3-yang")
set(TOOLS_PACKAGE "libyang-tools")

find_program(DEB_BUILDER NAMES debuild)
find_program(RPM_BUILDER NAMES rpmbuild)

# setup package build
configure_file(${PROJECT_SOURCE_DIR}/packages/${PACKAGE}.spec.in ${PROJECT_BINARY_DIR}/build-packages/${PACKAGE}.spec)
configure_file(${PROJECT_SOURCE_DIR}/packages/${PACKAGE}.dsc.in ${PROJECT_BINARY_DIR}/build-packages/${PACKAGE}.dsc)
configure_file(${PROJECT_SOURCE_DIR}/packages/debian.control.in ${PROJECT_BINARY_DIR}/build-packages/debian.control @ONLY)
configure_file(${PROJECT_SOURCE_DIR}/packages/debian.rules.in ${PROJECT_BINARY_DIR}/build-packages/debian.rules)
configure_file(${PROJECT_SOURCE_DIR}/packages/debian.compat
               ${PROJECT_BINARY_DIR}/build-packages/debian.compat COPYONLY)
configure_file(${PROJECT_SOURCE_DIR}/packages/debian.copyright
               ${PROJECT_BINARY_DIR}/build-packages/debian.copyright COPYONLY)
configure_file(${PROJECT_SOURCE_DIR}/packages/${PACKAGE}.rpmlintrc
               ${PROJECT_BINARY_DIR}/build-packages/${PACKAGE}.rpmlintrc COPYONLY)
configure_file(${PROJECT_SOURCE_DIR}/packages/debian.${PACKAGE}.install
               ${PROJECT_BINARY_DIR}/build-packages/debian.${PACKAGE}${LIBYANG_MAJOR_SOVERSION}.install COPYONLY)
configure_file(${PROJECT_SOURCE_DIR}/packages/debian.${PACKAGE}-dev.install
               ${PROJECT_BINARY_DIR}/build-packages/debian.${PACKAGE}-dev.install COPYONLY)
configure_file(${PROJECT_SOURCE_DIR}/packages/debian.${CPP_PACKAGE}.install
               ${PROJECT_BINARY_DIR}/build-packages/debian.${CPP_PACKAGE}${LIBYANG_MAJOR_SOVERSION}.install COPYONLY)
configure_file(${PROJECT_SOURCE_DIR}/packages/debian.${CPP_PACKAGE}-dev.install
               ${PROJECT_BINARY_DIR}/build-packages/debian.${CPP_PACKAGE}-dev.install COPYONLY)
# no python package for Debian because there is only SWIG 3.10 on Debian 9 :-/
#configure_file(${PROJECT_SOURCE_DIR}/packages/debian.${PYTHON_PACKAGE}.install
#               ${PROJECT_BINARY_DIR}/build-packages/debian.${PYTHON_PACKAGE}${LIBYANG_MAJOR_SOVERSION}.install COPYONLY)

if(NOT DEB_BUILDER)
    message(STATUS "Missing tools (devscripts, debhelper package) for building DEB package.")
else()
    # target for local build deb package
    message(STATUS "To build local DEB package, use \"build-deb\" target.")
    add_custom_target(build-deb
                      WORKING_DIRECTORY ${PROJECT_BINARY_DIR}
                      COMMAND build-packages/local-deb.sh
    )
    configure_file(${PROJECT_SOURCE_DIR}/packages/local-deb.sh.in ${PROJECT_BINARY_DIR}/build-packages/local-deb.sh @ONLY)
endif()

if(NOT RPM_BUILDER)
    message(STATUS "Missing tools (rpm package) for building RPM package.")
else()
    # target for local build rpm package
    message(STATUS "To build local RPM package, use \"build-rpm\" target.")
    string(REPLACE ${PROJECT_SOURCE_DIR} "." EXCLUDE_BUILD_DIR ${PROJECT_BINARY_DIR})
    add_custom_target(build-rpm
                      WORKING_DIRECTORY ${PROJECT_BINARY_DIR}
                      COMMAND build-packages/local-rpm.sh
    )
    configure_file(${PROJECT_SOURCE_DIR}/packages/local-rpm.sh.in ${PROJECT_BINARY_DIR}/build-packages/local-rpm.sh @ONLY)
endif()

=== swig/CMakeLists.txt ===
--- 
+++ 
@@ -99,6 +99,12 @@
     endif()
 endif()
 
+if(ENABLE_STATIC AND PYTHONLIBS_FOUND AND PYTHONINTERP_FOUND AND (${GEN_PYTHON_VERSION} STREQUAL "2" OR ${GEN_PYTHON_VERSION} STREQUAL "3"))
+    message(WARNING "Can't create a static Python module")
+elseif(PYTHONLIBS_FOUND AND PYTHONINTERP_FOUND AND (${GEN_PYTHON_VERSION} STREQUAL "2" OR ${GEN_PYTHON_VERSION} STREQUAL "3"))
+    add_subdirectory(python)
+endif()
+
 if(NOT ENABLE_STATIC AND GEN_JAVASCRIPT_BINDINGS)
     message(WARNING "Can't create Javascript bindings with a shared library, please use -DENABLE_STATIC")
 elseif(ENABLE_STATIC AND GEN_JAVASCRIPT_BINDINGS)

=== tests/CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8.12)

# Correct RPATH usage on OS X
set(CMAKE_MACOSX_RPATH TRUE)

# Set TESTS_DIR to realpath
get_filename_component(TESTS_DIR "${CMAKE_SOURCE_DIR}/tests" REALPATH)

set(api_tests test_libyang test_tree_schema test_xml test_dict test_tree_data test_tree_data_dup test_tree_data_merge test_xpath test_xpath_1.1 test_diff)
set(data_tests test_data_initialization test_leafref_remove test_instid_remove test_keys test_autodel test_when test_when_1.1 test_must_1.1 test_defaults test_emptycont test_unique test_mandatory test_json test_parse_print test_values test_metadata test_yangtypes_xpath test_yang_data test_yang_data_ns test_unknown_element test_user_types)
set(schema_yin_tests test_print_transform)
set(schema_tests test_ietf test_augment test_deviation test_refine test_typedef test_import test_include test_feature test_conformance test_leaflist test_status test_printer test_invalid)
if(CMAKE_BUILD_TYPE MATCHES debug)
    list(APPEND schema_tests test_extensions)
endif(CMAKE_BUILD_TYPE MATCHES debug)
set(conformance_tests test_sec6_1_1 test_sec6_2 test_sec5_1 test_sec5_5 test_sec6_1_3 test_sec6_2_1 test_sec7_1 test_sec7_2 test_sec7_3 test_sec7_3_1 test_sec7_3_4 test_sec7_5_2 test_sec7_5_4 test_sec7_5_5 test_sec7_6_2 test_sec7_6_3 test_sec7_6_4 test_sec7_6_5 test_sec7_7_2 test_sec7_7_3 test_sec7_7_4 test_sec7_7_5 test_sec7_8_1 test_sec7_8_2 test_sec7_8_3 test_sec7_9_1 test_sec7_9_2 test_sec7_9_3 test_sec7_9_4 test_sec7_10 test_sec7_11 test_sec7_12_1 test_sec7_12_2 test_sec7_13_1 test_sec7_13_2 test_sec7_13_3 test_sec7_14 test_sec7_15 test_sec7_15_1 test_sec7_16_1 test_sec7_16_2 test_sec7_18_1 test_sec7_18_2 test_sec7_18_3_1 test_sec7_18_3_2 test_sec7_19_1 test_sec7_19_2 test_sec7_19_5 test_sec9_2 test_sec9_3 test_sec9_4_4 test_sec9_4_6 test_sec9_5 test_sec9_6 test_sec9_7 test_sec9_8 test_sec9_9 test_sec9_10 test_sec9_11 test_sec9_12 test_sec9_13)
set(internal_tests test_lyb test_hash_table test_state_lists)

include_directories(SYSTEM ${CMOCKA_INCLUDE_DIR})

foreach(test_name IN LISTS api_tests)
    add_executable(${test_name} api/${test_name}.c)
endforeach(test_name)

foreach(test_name IN LISTS data_tests)
    add_executable(${test_name} data/${test_name}.c)
endforeach(test_name)

foreach(test_name IN LISTS schema_yin_tests)
    add_executable(${test_name} schema/yin/${test_name}.c)
endforeach(test_name)

foreach(test_name IN LISTS schema_tests)
    add_executable(${test_name} schema/${test_name}.c)
endforeach(test_name)

foreach(test_name IN LISTS conformance_tests)
    add_executable(${test_name} conformance/${test_name}.c)
endforeach(test_name)

foreach(test_name IN LISTS internal_tests)
    add_executable(${test_name} internal/${test_name}.c $<TARGET_OBJECTS:yangobj_tests>)
endforeach(test_name)

# Set common attributes of all tests
foreach(test_name IN LISTS api_tests data_tests schema_yin_tests schema_tests conformance_tests internal_tests)
    target_link_libraries(${test_name} ${CMOCKA_LIBRARIES} yang)
    add_test(NAME ${test_name} COMMAND $<TARGET_FILE:${test_name}>)
    set_property(TEST ${test_name} PROPERTY ENVIRONMENT "LIBYANG_EXTENSIONS_PLUGINS_DIR=${CMAKE_BINARY_DIR}/src/extensions")
    set_property(TEST ${test_name} APPEND PROPERTY ENVIRONMENT "LIBYANG_USER_TYPES_PLUGINS_DIR=${CMAKE_BINARY_DIR}/src/user_types")
    set_property(TEST ${test_name} APPEND PROPERTY ENVIRONMENT "MALLOC_CHECK_=3")
endforeach(test_name)

configure_file("${PROJECT_SOURCE_DIR}/tests/config.h.in" "${PROJECT_BINARY_DIR}/tests/config.h" ESCAPE_QUOTES @ONLY)
include_directories(${PROJECT_BINARY_DIR})

find_program(VALGRIND_FOUND valgrind)
if(ENABLE_VALGRIND_TESTS)
    if(VALGRIND_FOUND)
        foreach(test_name IN LISTS api_tests data_tests schema_yin_tests schema_tests conformance_tests internal_tests)
            add_test(${test_name}_valgrind valgrind --leak-check=full --show-leak-kinds=all --suppressions=${PROJECT_SOURCE_DIR}/tests/ld.supp --error-exitcode=1
                ${CMAKE_BINARY_DIR}/tests/${test_name})
            set_property(TEST ${test_name}_valgrind PROPERTY ENVIRONMENT "LIBYANG_EXTENSIONS_PLUGINS_DIR=${CMAKE_BINARY_DIR}/src/extensions")
            set_property(TEST ${test_name}_valgrind APPEND PROPERTY ENVIRONMENT "LIBYANG_USER_TYPES_PLUGINS_DIR=${CMAKE_BINARY_DIR}/src/user_types")
        endforeach(test_name)
    else(VALGRIND_FOUND)
        message(WARNING "valgrind executable not found! Disabling memory leaks tests.")
    endif(VALGRIND_FOUND)
endif(ENABLE_VALGRIND_TESTS)

if(ENABLE_CALLGRIND_TESTS)
    string(TOLOWER ${CMAKE_BUILD_TYPE} BUILD_TYPE)
    if(NOT (BUILD_TYPE STREQUAL "release"))
        message(WARNING "Not a release build type! Callgrind results may be inaccurate.")
    endif()

    if(VALGRIND_FOUND)
        find_path(VALGRIND_INCLUDE_DIRS NAMES valgrind/callgrind.h PATHS /usr/include /usr/local/include)
        if(VALGRIND_INCLUDE_DIRS)
            add_subdirectory(callgrind)
        else(VALGRIND_INCLUDE_DIRS)
            message(WARNING "valgrind include files not found! Disabling callgrind tests.")
        endif(VALGRIND_INCLUDE_DIRS)
    else(VALGRIND_FOUND)
        message(WARNING "valgrind executable not found! Disabling callgrind tests.")
    endif(VALGRIND_FOUND)
endif(ENABLE_CALLGRIND_TESTS)

=== src/extensions/CMakeLists.txt ===
macro(EXTENSION_PLUGIN PLUGIN_NAME SRCS)
    add_library(${PLUGIN_NAME} SHARED ${SRCS})
    set_target_properties(${PLUGIN_NAME} PROPERTIES PREFIX "")
    target_link_libraries(${PLUGIN_NAME} yang)
    install(TARGETS ${PLUGIN_NAME} DESTINATION ${EXTENSIONS_PLUGINS_DIR_MACRO})
endmacro(EXTENSION_PLUGIN)

foreach(EXTENSION ${EXTENSIONS_LIST})
    EXTENSION_PLUGIN(${EXTENSION} "${EXTENSION}.c")
endforeach()

=== src/user_types/CMakeLists.txt ===
macro(USER_TYPE_PLUGIN PLUGIN_NAME SRCS)
    add_library(${PLUGIN_NAME} SHARED ${SRCS} $<TARGET_OBJECTS:compat>)
    set_target_properties(${PLUGIN_NAME} PROPERTIES PREFIX "")
    target_link_libraries(${PLUGIN_NAME} yang)
    install(TARGETS ${PLUGIN_NAME} DESTINATION ${USER_TYPES_PLUGINS_DIR_MACRO})
endmacro(USER_TYPE_PLUGIN)

foreach(USER_TYPE ${USER_TYPE_LIST})
    USER_TYPE_PLUGIN(${USER_TYPE} ${USER_TYPE}.c)
endforeach()

=== tests/fuzz/CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8.12)

set(fuzz_targets yangfuzz xmlfuzz)

foreach(target_name IN LISTS fuzz_targets)
    add_executable(${target_name} ${target_name}.c)
    target_link_libraries(${target_name} yang)
endforeach(target_name)

=== debian/changelog ===
libyang (1.0.225-1.1) unstable; urgency=medium

  * Non-maintainer upload.
  * debian/tests/control: Remove test for no longer built python3-yang
    (Closes: #989886)

 -- Sebastian Ramacher <sramacher@debian.org>  Wed, 23 Jun 2021 22:46:11 +0200

libyang (1.0.225-1) unstable; urgency=medium

  * New upstream release

 -- Ondřej Surý <ondrej@debian.org>  Mon, 08 Mar 2021 15:39:56 +0100

libyang (1.0.215-1) unstable; urgency=medium

  * Remove C++ symbols file, it's mostly impossible to maintain
  * Update the libyang1 symbols file with the new symbol

 -- Ondřej Surý <ondrej@debian.org>  Tue, 02 Mar 2021 14:27:37 +0100

=== debian/control ===
Source: libyang
Section: libs
Homepage: https://netopeer.liberouter.org/
Maintainer: David Lamparter <equinox-debian@diac24.net>
Uploaders: CESNET <rkrejci@cesnet.cz>,
           Ondřej Surý <ondrej@debian.org>
Priority: optional
Standards-Version: 4.5.0
Build-Depends: bison,
               cmake,
               debhelper (>= 9.20150101),
               libcmocka-dev <!nocheck>,
               libpcre3-dev,
               pkg-config
Vcs-Browser: https://github.com/CESNET/libyang/tree/debian/master
Vcs-Git: https://github.com/CESNET/libyang.git -b debian/master

Package: libyang1
Depends: ${misc:Depends},
         ${shlibs:Depends}
Architecture: any
Description: parser toolkit for IETF YANG data modeling - runtime
 Libyang implements functions to process schemas expressed in the
 YANG data modeling language defined by the IETF in RFCs 6020/7950.
 Schemas expressed in this language primarily describe configuration
 used by larger network equipment like routers and switches.
 .
 In addition to handling the schemas itself, the library also provides
 functions to process data described by the schemas.
 .
 The library is implemented in C and provides an API for other software
 to use in processing configurations.

Package: libyang-dev
Depends: libpcre3-dev,
         libyang1 (= ${binary:Version}),
         ${misc:Depends}
Section: libdevel
Architecture: any
Description: parser toolkit for IETF YANG data modeling - development files
 Libyang implements functions to process schemas expressed in the
 YANG data modeling language defined by the IETF in RFCs 6020/7950.
 Schemas expressed in this language primarily describe configuration
 used by larger network equipment like routers and switches.
 .
 In addition to handling the schemas itself, the library also provides
 functions to process data described by the schemas.
 .
 This package contains the C headers, a pkgconfig file, and .so entry point
 for libyang.

Package: libyang-tools
Depends: libyang1 (= ${binary:Version}),
         ${misc:Depends},
         ${shlibs:Depends}
Breaks: yang-tools (<< ${source:Version})
Replaces: yang-tools (<< ${source:Version})
Section: devel
Architecture: any
Description: parser toolkit for IETF YANG data modeling - executable tools
 This package provides the "yanglint" and "yangre" tools which can be used
 during the creation of IETF YANG schemas.  The tools are not generally
 useful for normal operation where libyang primarily processes configuration
 data, not schemas.

Package: libyang-cpp1
Depends: libyang1 (= ${binary:Version}),
         ${misc:Depends},
         ${shlibs:Depends}
Architecture: any
Description: parser toolkit for IETF YANG data modeling - C++ runtime
 Partially SWIG-generated bindings to use libyang with a C++ API.
 The functionality is the same as in libyang, the C++ code links wraps
 and uses libyang C code.

Package: libyang-cpp-dev
Depends: libyang-cpp1 (= ${binary:Version}),
         libyang-dev (= ${binary:Version}),
         ${misc:Depends}
Section: libdevel
Architecture: any
Description: parser toolkit for IETF YANG data modeling - C++ development files
 Partially SWIG-generated bindings to use libyang with a C++ API.
 The functionality is the same as in libyang, the C++ code links wraps
 and uses libyang C code.
 .
 This is the accompanying development package, containing headers, a
 pkgconfig file, and .so entry point for the libyang C++ bindings.

Package: yang-tools
Depends: libyang-tools (>= ${source:Version}),
         ${misc:Depends}
Section: oldlibs
Architecture: all
Description: parser toolkit for IETF YANG data modeling [dummy package]
 This is empty dependency package to pull the executable tools.  It's
 safe to remove.

=== debian/rules ===
#!/usr/bin/make -f
#export DH_VERBOSE=1
export DEB_BUILD_MAINT_OPTIONS = hardening=+all

include /usr/share/dpkg/default.mk

%:
	dh $@

override_dh_auto_configure:
	dh_auto_configure -- \
		-DCMAKE_BUILD_TYPE:String="Package" \
		-DENABLE_LYD_PRIV=ON \
		-DGEN_LANGUAGE_BINDINGS=ON \
		-DGEN_JAVA_BINDINGS=OFF \
		-DGEN_JAVASCRIPT_BINDINGS=OFF \
		-DGEN_PYTHON_BINDINGS=OFF

override_dh_auto_test:
ifeq ($(filter nocheck,$(DEB_BUILD_OPTIONS)),)
	make -C obj-$(DEB_HOST_GNU_TYPE) test ARGS=-V
endif
